#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

void gauss(double a_jac[2][2],double s[2],int n)
{
	int i,j;
	for(i=1;i<=n;i++)
	{
		s[i] = fabs(a_jac[i][1]);
		for(j=2;j<=n;j++)
		{
			if(fabs(a_jac[i][j])>s[i])
			{
			s[i]=fabs(a_jac[i][j]);
			}
		}
	}
}

void pivot(double a_jac[2][2],double s[2],double a_ivs[2][2],int k,int n) 
{
	int i,j,p;
	double big,dummy;

	p=k;
	big=fabs(a_jac[k][k]/s[k]);
	for(i=k+1;i<=n;i++)
	{
		dummy=fabs(a_jac[i][k]/s[i]);
		if(dummy>big)
		{
			big=dummy;
			p=i;
		}
	}

	if(p!=k)
	{
		for(j=1;j<=n;j++)
		{
			dummy=a_jac[p][j];
			a_jac[p][j]=a_jac[k][j];
			a_jac[k][j]=dummy;
			dummy=a_ivs[p][j];
			a_ivs[p][j]=a_ivs[k][j];
			a_ivs[k][j]=dummy;
		}
		dummy=s[p];
		s[p]=s[k];
		s[k]=dummy;
	}
}

int eliminate(double a_jac[2][2],double s[2],double a_ivs[2][2],int n,int er)
{
	int i,j,k=0;
	double factor;
	for(i=1;i<=2;i++)
	{
		for(j=1;j<=2;j++)
		{
			if(i==j)
			{
				a_ivs[i][j]=1;
			}
			else
			a_ivs[i][j]=0;
		}
	}
	for(k=1;k<=n;k++)
	{
		pivot(a_jac,s,a_ivs,k,n);
		if(fabs(a_jac[k][k]/s[k]) < 0.000000000000001)
		{
			er=-1;
		}
		else
		{
			er=1;
		}
		for(i=k+1;i<=n;i++)
		{
			factor=a_jac[i][k]/a_jac[k][k];
			for(j=1;j<=n;j++)
			{
				a_jac[i][j]=a_jac[i][j]-factor*a_jac[k][j];
				a_ivs[i][j]=a_ivs[i][j]-factor*a_ivs[k][j];
			}
		}
	}
	
	for(k=n;k>=1;k--)
	{
		for(i=k-1;i>=1;i--)
		{
			factor=a_jac[i][k]/a_jac[k][k];
			for(j=n;j>=1;j--)
			{
				a_jac[i][j]=a_jac[i][j]-factor*a_jac[k][j];
				a_ivs[i][j]=a_ivs[i][j]-factor*a_ivs[k][j];
			}
		}
	}

	for(i=1;i<=n;i++)
	{
		for(j=1;j<=n;j++)
		{
			a_ivs[i][j]=a_ivs[i][j]/a_jac[i][i];
		}
	}

	return er;
}

//jacobian fuction
void jaco(double a_jac[2][2],double x_ge_l,double x_ge_s,double T)
{
	a_jac[1][1]=8.31451*T/(x_ge_l-1);
	a_jac[1][2]=8.31451*T/(1-x_ge_s);
	a_jac[2][1]=8.31451*T/x_ge_l;
	a_jac[2][2]=-8.31451*T/x_ge_s;
}

double f1(double x_ge_l,double x_ge_s,double T)
{
	double p;
	p=(36944.72-30.4975*T)+8.31451*T*(log(1-x_ge_l)-log(1-x_ge_s));
	return p;
}

double f2(double x_ge_l,double x_ge_s,double T)
{
	double p;
	p=(50208.00-29.7617*T)+8.31451*T*(log(x_ge_l)-log(x_ge_s));
	return p;
}

void main()
{
	double a_jac[2][2],a[2][2],a_ivs[2][2];
	double s[2];
	double x_ge_l,x_ge_s;
	double T=0,T_Max,T_min;
	double dummy;
	int i,j,n,iter,er=1;
	FILE *pt;//file input 


	n=2;

	// a_ivs array initializing
	for(i=1;i<=2;i++)
	{
		for(j=1;j<=2;j++)
		{
			if(i==j)
			{
				a_ivs[i][j]=1;
			}
			else
			a_ivs[i][j]=0;
		}
	}
//Temperature minimun, Maximun ޴´.
	printf("You can choose Temperature!\n");
	printf("What is minimum? : ");
	scanf("%lf",&T_min);
	printf("What is Maximum? : ");
	scanf("%lf",&T_Max);
	


	pt=fopen("hw5.txt","w");
	fprintf(pt,"x_ge_l             x_ge_s                T \n");


	for(T=T_min;T<=T_Max;T=T+4)
	{
		//f1Լ f2Լ 밪  10^-8 Ǹ ׸
		for(x_ge_l=0.3,x_ge_s=0.7,iter=0;fabs(f1(x_ge_l,x_ge_s,T))>0.00000001 || fabs(f2(x_ge_l,x_ge_s,T))>0.00000001;iter++)
		{
			jaco(a,x_ge_l,x_ge_s,T);
			gauss(a,s,n);
			er=eliminate(a,s,a_ivs,n,er);
			if(er==-1)//Լ  ʴ´ٸ x ణ ٸ Ѵ.
			{
				x_ge_l=x_ge_l+0.00001;
				er=eliminate(a,s,a_ivs,n,er);
			}
			dummy=x_ge_l;
			x_ge_l=x_ge_l-a_ivs[1][1]*f1(x_ge_l,x_ge_s,T)-a_ivs[1][2]*f2(x_ge_l,x_ge_s,T);
			x_ge_s=x_ge_s-a_ivs[2][1]*f1(dummy,x_ge_s,T)-a_ivs[2][2]*f2(dummy,x_ge_s,T);
			
			//x 0 Ȥ 1̸̻ α   Ƿ 
			if(x_ge_l<=0)
			{
				x_ge_l=(rand()%9+1)*0.1;
			}
			if(x_ge_l>=1)
			{
				x_ge_l=(rand()%9+1)*0.1;
			}
			if(x_ge_s<=0)
			{
				x_ge_s=(rand()%9+1)*0.1;
			}
			if(x_ge_s>=1)
			{
				x_ge_s=(rand()%9+1)*0.1;
			}

			//iteration 100000 Ǹ    	
			if(iter==100000)
			{
				fprintf(pt,"%f K is not available!\n", T);
				break;
			}
		}
		if(iter!=100000)
		{
		fprintf(pt,"%.12f  %.12f  %.12f\n",x_ge_l,x_ge_s,T);
		}
	}
	fclose(pt);	


	if(er==-1)
	{
		printf("error!!\n");
	}
	else
	{
		printf("Finished! Open hw5.txt!\n");
	}	
	getch();
}